'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Cell;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Cell(props) {
  var renderCell = function renderCell() {
    var handleOnClick = function handleOnClick(field, valPlain, dataItem, ev) {
      props.onCellClick(field, valPlain, dataItem);
      ev.preventDefault();
    };

    var data = props.data;
    var valPlain = data[props.field];

    var valFormatted = valPlain;
    if (props.renderer) {
      valFormatted = props.renderer(data);
    }

    if (props.isClickable && (valPlain !== '' || props.renderer)) {
      valFormatted = _react2.default.createElement(
        'span',
        { onClick: function onClick(ev) {
            return handleOnClick(props.field, valPlain, data, ev);
          } },
        valFormatted
      );
    }

    if (valFormatted === '') {
      if (props.emptyPlaceholder !== '') valFormatted = props.emptyPlaceholder;
    }

    return valFormatted;
  };

  return _react2.default.createElement(
    'td',
    { className: props.className },
    renderCell(),
    props.children
  );
}

Cell.defaultProps = {
  onCellClick: function onCellClick() {},
  isClickable: false
};

Cell.propTypes = {
  onCellClick: _propTypes2.default.func,
  isClickable: _propTypes2.default.bool
};