'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Column = exports.Grid = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _paginator = require('./paginator');

var _paginator2 = _interopRequireDefault(_paginator);

var _header = require('./header');

var _header2 = _interopRequireDefault(_header);

var _column = require('./column');

var _column2 = _interopRequireDefault(_column);

var _cell = require('./cell');

var _cell2 = _interopRequireDefault(_cell);

var _expandableCell = require('./expandableCell');

var _expandableCell2 = _interopRequireDefault(_expandableCell);

var _freeSolidSvgIcons = require('@fortawesome/free-solid-svg-icons');

var _reactFontawesome = require('@fortawesome/react-fontawesome');

var _all = require('./plugins/all');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Grid = function (_Component) {
  _inherits(Grid, _Component);

  function Grid(props) {
    _classCallCheck(this, Grid);

    // set final state
    var _this = _possibleConstructorReturn(this, (Grid.__proto__ || Object.getPrototypeOf(Grid)).call(this, props));

    _this.state = _this.buidState(props);
    return _this;
  }

  _createClass(Grid, [{
    key: 'buidState',
    value: function buidState(props) {
      // prepare default state variable
      // all these items can be altered by the plugins
      var state = {
        data: props.data, // data that will be displayed by the grid

        onRowClick: function onRowClick() {}, // event invoked when a row is clicked
        onRowMouseOver: function onRowMouseOver() {},
        onRowMouseOut: function onRowMouseOut() {},
        onRowMouseDown: function onRowMouseDown() {},
        rowClassNames: function rowClassNames(args) {
          return props.classNamesRenderer(args);
        },
        gridClassNames: function gridClassNames() {
          return ['digital-grid'];
        },
        footerText: props.footerText
      };

      // enable plugins that change initial state
      return _all.plugins.initAll(this, state);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      // refresh the state every time there is new data sent
      if (JSON.stringify(prevProps.data) !== JSON.stringify(this.props.data)) {
        var _state = this.buidState(this.props);
        // reset state if different
        if (JSON.stringify(_state) !== JSON.stringify(prevState)) {
          this.setState(_state);
        }
      }
    }
  }, {
    key: 'itemContent',
    value: function itemContent(item, index) {
      var _this2 = this;

      // TO DO: document this as row events parameters /issues/16
      var params = {
        item: item,
        grid: this
      };

      var _props = this.props,
          keyField = _props.keyField,
          isExpandable = _props.isExpandable;

      var key = keyField ? item[keyField] : index;
      var classNames = this.state.rowClassNames(params);

      return _react2.default.createElement(
        _react2.default.Fragment,
        {
          key: key },
        _react2.default.createElement(
          'tr',
          {
            className: classNames.join(' '),
            onClick: function onClick(event) {
              return _this2.state.onRowClick(_extends({ event: event }, params));
            },
            onMouseDown: function onMouseDown(event) {
              return _this2.state.onRowMouseDown(_extends({ event: event }, params));
            },
            onMouseOver: function onMouseOver(event) {
              return _this2.state.onRowMouseOver(_extends({ event: event }, params));
            },
            onMouseOut: function onMouseOut(event) {
              return _this2.state.onRowMouseOut(_extends({ event: event }, params));
            } },
          this.rowContent(item)
        ),
        isExpandable && item.isExpanded && _react2.default.createElement(
          'tr',
          null,
          _react2.default.createElement(
            'td',
            null,
            ' '
          ),
          _react2.default.createElement(
            'td',
            { colSpan: this.props.children.length },
            _react2.default.cloneElement(this.props.expandedRowContent(item), {
              data: item
            })
          )
        )
      );
    }
  }, {
    key: 'rowContent',
    value: function rowContent(item) {
      var _this3 = this;

      var children = this.getColumns();
      var isExpandable = this.props.isExpandable;
      var data = this.state.data;


      return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        _react2.default.createElement(_expandableCell2.default, {
          isVisible: isExpandable,
          isExpanded: item.isExpanded,
          onExpand: function onExpand(event) {
            event.preventDefault();
            var copyItems = [].concat(_toConsumableArray(data));
            var index = copyItems.indexOf(item);
            copyItems[index] = _extends({}, copyItems[index]);
            copyItems[index].isExpanded = !copyItems[index].isExpanded;
            _this3.setState({ data: copyItems });
          }
        }),
        _react2.default.Children.map(children, function (child, i) {
          return _react2.default.createElement(_cell2.default, _extends({}, child.props, {
            data: item,
            onCellClick: _this3.props.onCellClick,
            emptyPlaceholder: _this3.props.emptyPlaceholder
          }));
        })
      );
    }
  }, {
    key: 'renderRows',
    value: function renderRows(columns) {
      var _this4 = this;

      var _props2 = this.props,
          emptyText = _props2.emptyText,
          isExpandable = _props2.isExpandable,
          loading = _props2.loading;
      var data = this.state.data;

      var noData = !data || data.length === 0;

      if (loading && noData) {
        return _react2.default.createElement(
          'tr',
          { key: 'loading' },
          _react2.default.createElement(
            'td',
            {
              colSpan: this.props.children.length + (isExpandable ? 1 : 0),
              className: 'bold center' },
            _react2.default.createElement(_reactFontawesome.FontAwesomeIcon, { icon: _freeSolidSvgIcons.faSync, className: 'fa-spin mr4' }),
            ' Loading data ...'
          )
        );
      } else {
        if (noData) {
          return _react2.default.createElement(
            'tr',
            { key: 'empty' },
            _react2.default.createElement(
              'td',
              { colSpan: this.props.children.length + (isExpandable ? 1 : 0), className: 'center' },
              emptyText
            )
          );
        } else {
          return data.map(function (item, index) {
            return _this4.itemContent(item, index);
          });
        }
      }
    }
  }, {
    key: 'handlePageChange',
    value: function handlePageChange(newPage) {
      this.props.onStateChange({
        pageSize: this.props.pageSize,
        pageNr: newPage,
        orderBy: this.props.orderBy,
        orderDir: this.props.orderDir
      });
    }
  }, {
    key: 'handleSortChange',
    value: function handleSortChange(newOrderBy, neworderDir) {
      this.props.onStateChange({
        pageSize: this.props.pageSize,
        pageNr: 1,
        orderBy: newOrderBy,
        orderDir: neworderDir
      });
    }
  }, {
    key: 'getColumns',
    value: function getColumns() {
      var children = [];
      var validType = function validType(child) {
        return _react2.default.isValidElement(child) && child.type === _column2.default;
      };

      // allow only valid Columns in main collection and inside it (in case we have an empty container)
      _react2.default.Children.toArray(this.props.children).map(function (child) {
        if (validType(child)) {
          children.push(child);
        } else {
          if (_react2.default.isValidElement(child) && child.props.children) {
            _react2.default.Children.toArray(child.props.children).map(function (subChild) {
              if (validType(subChild)) {
                children.push(subChild);
              }

              return null;
            });
          }
        }

        return null;
      });

      return children;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this5 = this;

      //console.log("DIGITAL GRID - Rendering grid. loading:", this.props.loading, ', data: ', this.state.data ? this.state.data.length: false);
      var columns = this.getColumns();
      var noData = !this.state.data || this.state.data.length === 0;
      var gridClassNames = this.state.gridClassNames();
      gridClassNames.push('skin-' + this.props.skin);
      if (this.props.className) gridClassNames.push(this.props.className);

      return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        _react2.default.createElement(
          'table',
          {
            className: gridClassNames.join(' '),
            style: { opacity: this.props.loading && !noData ? 0.4 : 1 } },
          _react2.default.createElement(
            'thead',
            null,
            _react2.default.createElement(
              'tr',
              null,
              _react2.default.createElement('th', {
                key: 'emptyHeader',
                style: this.props.isExpandable && columns.length >= 1 ? {} : { display: 'none' } }),
              _react2.default.Children.map(columns, function (column, i) {
                return _react2.default.createElement(_header2.default, _extends({}, column.props, {
                  orderBy: _this5.props.orderBy,
                  key: i,
                  orderDir: _this5.props.orderDir,
                  onSortChanged: function onSortChanged(orderBy, orderDir) {
                    return _this5.handleSortChange(orderBy, orderDir);
                  }
                }));
              })
            )
          ),
          _react2.default.createElement(
            'tbody',
            null,
            this.renderRows(columns)
          ),
          _react2.default.createElement(
            'tfoot',
            null,
            _react2.default.createElement(
              'tr',
              null,
              _react2.default.createElement(
                'td',
                { colSpan: this.props.children.length + (this.props.isExpandable ? 1 : 0) },
                this.props.dataCount > this.state.data.length && this.props.pageSize > 0 && _react2.default.createElement(_paginator2.default, {
                  pageNr: this.props.pageNr,
                  pageSize: this.props.pageSize,
                  dataCount: this.props.dataCount,
                  onPageChanged: function onPageChanged(page) {
                    return _this5.handlePageChange(page);
                  }
                }),
                this.state.footerText,
                (!this.props.loading || !noData) && this.props.isSelectable && this.props.showSelectionInfo && _react2.default.createElement(
                  'div',
                  { className: 'pt10' },
                  _react2.default.createElement(_reactFontawesome.FontAwesomeIcon, { icon: _freeSolidSvgIcons.faInfoCircle, style: { zoom: 1.2, paddingRight: '5px', float: 'left' } }),
                  _react2.default.createElement(
                    'div',
                    null,
                    'Row selection is enabled.',
                    _react2.default.createElement('br', null),
                    'Multiselect is also enabled by using the Shift and/or Ctrl keys.'
                  )
                )
              )
            )
          )
        )
      );
    }
  }]);

  return Grid;
}(_react.Component);

Grid.defaultProps = {
  emptyText: 'No data available!', // Text to be displayed when there is no data to available. Defaults to 'No data available'
  footerText: '', // Text to be displayed in the bottom of the grid. Defaults to '' (empty).
  className: '', // Additional className of the grid table. Defaults to '' (empty).
  classNamesRenderer: function classNamesRenderer() {
    return [];
  }, // Method to compute additional className for each row. Parameters: see row events parameters.
  onCellClick: function onCellClick() {}, // Callback method to be called (if set) when clicking a column value.
  emptyPlaceholder: '-', // Text to be displayed in each grid cell if the content is empty.

  skin: 'default', // Skin of the grid. Can be: 'default', 'classic', 'bootstrap' or 'none'. Defalts to 'default'.

  isSelectable: false, // Sets if the grid is selectable. It true, rows can be (multi)selected. Defaults for 'false'.
  showSelectionInfo: true, // Sets if the selection info is displayed in the footer of the grid. Defaults for 'false'.
  onSelectionChange: function onSelectionChange() {}, // Callback method called when the selection of the rows changed. Parameters: (selectedKeys, selectedItems, selectedLast)

  isExpandable: false, // Sets if the grid is expandable. If 'true' will display in the first column a [+] sign that expands the current row. Defaults to 'false'.
  expandedRowContent: function expandedRowContent() {
    return null;
  }, // Method used to generate the content of an expanded column. Parameters: (item)

  data: [], // The data that the grid should display.
  keyField: null, // The field name of the data elements that represents a unique key.
  loading: false, // Sets if the grid should display a loading indicator. Defaults to 'false'.
  dataCount: 0, // The total records of the grid. This is not the count of the 'data' array, but total records for all pages. Used by the paginator to calculate total pages.
  pageNr: 1, // Curtent page to display. Used by the paginator render.
  pageSize: 0, // Current number of items to display on a page. Used by the paginator render.
  orderBy: '?', // Initial 'Order By' field.
  orderDir: 'ASC', // Initial 'Order Dir' field.
  onStateChange: function onStateChange() {} // Callback method called when the state of the grid (page, order by, order dir, etc...) is changed. Parameterd: (pageSize, pageNr, orderBy, orderDir).
};

Grid.propTypes = {
  emptyText: _propTypes2.default.string,
  footerText: _propTypes2.default.string,
  className: _propTypes2.default.string,

  classNamesRenderer: _propTypes2.default.func,
  onCellClick: _propTypes2.default.func,
  emptyPlaceholde: _propTypes2.default.string,

  skin: _propTypes2.default.oneOf(['none', 'default', 'classic', 'bootstrap']),

  isSelectable: _propTypes2.default.bool,
  showSelectionInfo: _propTypes2.default.bool,
  onSelectionChange: _propTypes2.default.func,

  isExpandable: _propTypes2.default.bool,
  expandedRowContent: _propTypes2.default.func,

  data: _propTypes2.default.array,
  keyField: _propTypes2.default.string,
  loading: _propTypes2.default.bool,
  dataCount: _propTypes2.default.number,
  pageNr: _propTypes2.default.number,
  pageSize: _propTypes2.default.number,
  orderBy: _propTypes2.default.string,
  orderDir: _propTypes2.default.string,
  onStateChange: _propTypes2.default.func
};

exports.Grid = Grid;
exports.Column = _column2.default;