'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _freeSolidSvgIcons = require('@fortawesome/free-solid-svg-icons');

var _reactFontawesome = require('@fortawesome/react-fontawesome');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Header = function Header(_ref) {
  var _ref$toolTip = _ref.toolTip,
      toolTip = _ref$toolTip === undefined ? '' : _ref$toolTip,
      _ref$classNames = _ref.classNames,
      classNames = _ref$classNames === undefined ? '' : _ref$classNames,
      _ref$headerClassName = _ref.headerClassName,
      headerClassName = _ref$headerClassName === undefined ? '' : _ref$headerClassName,
      _ref$sortable = _ref.sortable,
      sortable = _ref$sortable === undefined ? false : _ref$sortable,
      props = _objectWithoutProperties(_ref, ['toolTip', 'classNames', 'headerClassName', 'sortable']);

  var handleSortChange = function handleSortChange() {
    var isCurrent = props.field === props.orderBy;
    props.onSortChanged(props.field, !isCurrent ? 'ASC' : props.orderDir === 'ASC' ? 'DESC' : 'ASC');
  };

  var renderHeaderContent = function renderHeaderContent() {
    if (sortable) {
      var styles = {
        icon: props.field === props.orderBy ? props.orderDir === 'DESC' ? _freeSolidSvgIcons.faCaretDown : _freeSolidSvgIcons.faCaretUp : _freeSolidSvgIcons.faSort,
        class: props.field === props.orderBy ? 'active' : 'inactive'
      };

      return _react2.default.createElement(
        'table',
        { className: 'grid-sort-link', onClick: function onClick() {
            return handleSortChange();
          } },
        _react2.default.createElement(
          'tbody',
          null,
          _react2.default.createElement(
            'tr',
            null,
            _react2.default.createElement(
              'td',
              { className: 'pr5' },
              props.header
            ),
            _react2.default.createElement(
              'td',
              { className: 'align-middle' },
              _react2.default.createElement(_reactFontawesome.FontAwesomeIcon, { icon: styles.icon, className: styles.class })
            )
          )
        )
      );
    } else {
      return props.header;
    }
  };

  return _react2.default.createElement(
    'th',
    {
      className: props.className + ' grid-header-cell ' + headerClassName,
      title: toolTip + (toolTip && sortable ? '\n' : '') + (sortable ? 'Click to sort this using value!' : '')
    },
    _react2.default.createElement(
      'div',
      { className: 'gridHeader' },
      renderHeaderContent()
    )
  );
};

exports.default = Header;


Header.defaultProps = {
  className: ''
};