'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _freeSolidSvgIcons = require('@fortawesome/free-solid-svg-icons');

var _reactFontawesome = require('@fortawesome/react-fontawesome');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Paginator = function (_Component) {
  _inherits(Paginator, _Component);

  function Paginator() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Paginator);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Paginator.__proto__ || Object.getPrototypeOf(Paginator)).call.apply(_ref, [this].concat(args))), _this), _this.maximumNumberOfPageButtons = 11, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Paginator, [{
    key: 'computeModel',
    value: function computeModel() {
      var currentPage = this.props.pageNr;
      var pageSize = this.props.pageSize;
      var dataCount = this.props.dataCount;
      var totalNumberOfPages = Math.ceil(dataCount / pageSize);

      return {
        currentPageNumber: currentPage,
        totalNumberOfPages: totalNumberOfPages,
        firstPageButton: {
          number: 1,
          enabled: currentPage > 1
        },
        previousPageButton: {
          number: currentPage > 1 ? currentPage - 1 : 1,
          enabled: currentPage > 1
        },
        nextPageButton: {
          number: currentPage < totalNumberOfPages ? currentPage + 1 : totalNumberOfPages,
          enabled: currentPage < totalNumberOfPages
        },
        lastPageButton: {
          number: totalNumberOfPages,
          enabled: currentPage < totalNumberOfPages
        },
        displayResultsFrom: dataCount === 0 ? 0 : pageSize * (currentPage - 1) + 1,
        displayResultsTo: dataCount === 0 ? 0 : Math.min(pageSize * (currentPage - 1) + pageSize, dataCount),
        displayResultsTotal: dataCount
      };
    }
  }, {
    key: 'changePage',
    value: function changePage(pageNumber) {
      this.props.onPageChanged(pageNumber);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var model = this.computeModel();
      return _react2.default.createElement(
        'ul',
        { className: 'pagination' },
        _react2.default.createElement(
          'li',
          { className: (0, _classnames2.default)({ first: true, 'page-item': true, disabled: !model.firstPageButton.enabled }) },
          _react2.default.createElement(
            'span',
            { className: 'page-link', onClick: function onClick() {
                return _this2.changePage(model.firstPageButton.number);
              } },
            _react2.default.createElement(_reactFontawesome.FontAwesomeIcon, { icon: _freeSolidSvgIcons.faAngleDoubleLeft })
          )
        ),
        _react2.default.createElement(
          'li',
          { className: (0, _classnames2.default)({ prev: true, 'page-item': true, disabled: !model.previousPageButton.enabled }) },
          _react2.default.createElement(
            'span',
            { className: 'page-link', onClick: function onClick() {
                return _this2.changePage(model.previousPageButton.number);
              } },
            _react2.default.createElement(_reactFontawesome.FontAwesomeIcon, { icon: _freeSolidSvgIcons.faAngleLeft })
          )
        ),
        _react2.default.createElement(
          'li',
          { className: (0, _classnames2.default)({ page: true, 'page-item': true }) },
          _react2.default.createElement(
            'span',
            { className: 'nowrap page-link' },
            'Page ',
            model.currentPageNumber,
            ' of ',
            model.totalNumberOfPages
          )
        ),
        _react2.default.createElement(
          'li',
          { className: (0, _classnames2.default)({ next: true, 'page-item': true, disabled: !model.nextPageButton.enabled }) },
          _react2.default.createElement(
            'span',
            { className: 'page-link', onClick: function onClick() {
                return _this2.changePage(model.nextPageButton.number);
              } },
            _react2.default.createElement(_reactFontawesome.FontAwesomeIcon, { icon: _freeSolidSvgIcons.faAngleRight })
          )
        ),
        _react2.default.createElement(
          'li',
          { className: (0, _classnames2.default)({ last: true, 'page-item': true, disabled: !model.lastPageButton.enabled }) },
          _react2.default.createElement(
            'span',
            { className: 'page-link', onClick: function onClick() {
                return _this2.changePage(model.lastPageButton.number);
              } },
            _react2.default.createElement(_reactFontawesome.FontAwesomeIcon, { icon: _freeSolidSvgIcons.faAngleDoubleRight })
          )
        ),
        _react2.default.createElement(
          'li',
          { className: 'right page-item' },
          _react2.default.createElement(
            'span',
            { className: 'page-link' },
            'Displaying results ',
            model.displayResultsFrom,
            ' - ',
            model.displayResultsTo,
            ' of',
            ' ',
            model.displayResultsTotal
          )
        )
      );
    }
  }]);

  return Paginator;
}(_react.Component);

exports.default = Paginator;


Paginator.defaultProps = {
  onPageChanged: function onPageChanged() {}
};